use AppleScript version "2.4" -- Yosemite (10.10) or later
use scripting additions
use framework "AppKit"
use framework "Foundation"

property NSString : class "NSString"
property NSRegularExpression : class "NSRegularExpression"

(*
	Logical coparison operators
		"and"  logical "and" operation, the "&" symbol does not work for logical "and" in ASObj-C
		"or" logical "or" operation, the "|" symbol does not work for logical "and" in ASObj-C
		I don't think ASObj-C implrments an "exclusive OR" operator
*)

(*
	isEqual: Checks if what is given in the 2 parameters evaluates to the same thing, as opposed to the 2 parameters themseves being equal
	
	respondsToSelector: Checks to see if the specified object implements or inherts the specified method
*)

-- This returns true because what CocoaString evaluates to is equal to what AppleScriptString evaluates to
-- CocoaString's isEqual:AppleScriptString --> true

-- Note: AppleScriptString's isEqual:CocoaString   will not work because AppleScriptString is not a cocoa object
-- and therefore has no methods to call

(*
	There are other classes that have specialized equality methods e.g. NSString has a isEqualToString method, NSArray has a isEqualToArray method, ...
	But every class has an isEqual method.
*)

set TheLetter to (NSString's stringWithString:"T")
set LogicalTrue to (TheLetter's isEqual:"T")
set LogicalFalse to (TheLetter's isEqual:"F")

LogicalFalse and LogicalTrue --> false
LogicalTrue and LogicalTrue --> true

LogicalFalse or LogicalTrue --> true
LogicalTrue or LogicalTrue --> true

